# Governance of IQVIA-ML projects

<!-- *insert description of IQVIA* -->

## Contributions

We welcome all contributions, no matter how small. Pull Requests are gratefully received, as are bug reports. Pull Requests don't have to just be about the code - if you can improve the documentation that's also very useful. If you would like to contribute, please read and follow our [Contribution Guidelines](CONTRIBUTING.md) to help us keep the process smooth.

We want to ensure that we recognise everyone who has given their time to the project by listing them in the [All Contributors](https://allcontributors.org/) table in the [README file](README.md). If your efforts are not listed, please get in touch.

## How we do releases

We don't have a set release schedule, but we try to respect the mantra of "release early, release often". We will normally do hotfixes for fixing bugs as soon as the fix is ready and tested. Releases of new functionality, particularly if it breaks the API, will happen more slowly, with announcements in advance to help users prepare.

We follow the rules of [Semantic Versioning 2.0](https://semver.org/).

## Communication

We will keep discussions about current development and future goals for the project in the open. Development will be planned in GitHub issues (or similarly open tools) so that everyone from the community has a chance to discuss, debate and decide.

We will monitor threads on the [official Julia discourse](https://discourse.julialang.org/) about our projects, but for the now the best way to talk to us about bugs or feature requests is through GitHub issues.

We aim to respond to GitHub issues and pull requests within one week at most, but we'll try to acknowledge and give feedback much quicker than that.

## Code of Conduct

We do have a [Code of Conduct](CODE_OF_CONDUCT.md), we hope this will encourage people from all backgrounds to feel part of the community.

## Approvals

Pull Requests will need to pass automated status checks and at least one code review in order to be accepted. Currently reviewers are members of IQVIA but we hope members of the community will consider becoming reviewers in time. Pull Requests cannot be accepted by their own author, even if the author is a maintainer.
